using System;
using System.Windows.Forms;
using DicomObjects;
using DicomObjects.EventArguments;
using DicomObjects.Enums;
using DicomObjects.DicomUIDs;

namespace MPPS_SCU
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : Form
	{
		internal CheckBox EnableLog;
		internal TextBox Logger;
		internal Button InProgressBTN;
		internal Label Label1;
		private DicomDataSetCollection emptydss;
		private string UID, StudyUID;
		internal Button CompleteBTN;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private readonly System.ComponentModel.Container components = null;

        private const string PatientName = "Bloggs^Joe";
		private const string PatientId= "ID1";
		private const string Gender= "M";
		private const string DateFormat= "1962/12/31";
		private const string AccessionNumber = "12345";
		private const string RequestedProcedureID = "REQ_ID1";
		private const string RequestedProcedureDescription = "Requested Procedure Description";
		private const string ScheduledProcedureStepId = "STEP_ID1";
		private const string ScheduledProcedureStepDescription = "Scheduled Procedure Step Description";
		private const string PerformedStationAETitle = "AETitle";
		private const string PerformedStationName = "Station Name";
		private const string PerformedLocation = "Location";
		private const string PerformedProcedureStepID = "1";
		private const string PerformedProcedureStepDescription = "Performed Procedure Step Description";
		private const string PerformedProcedureTypeDescription = "Performed Procedure Type Description";
		private const string Modality = "CT";
		private const string StudyId = "ID1";
		private const string Node = "localhost";
		private const string CallingAE = "CALLING_AE";
		private const string CalledAE = "CALLED_AE";
		private const int Port = 104;
		private const string InProgress = "IN PROGRESS";
		private const string SucceededMessage = "Succeeded";
		private const string PerformedActionCodeValue = "PAI-1";
		private const string PerformedActionCodingSchemeDesignator = "DCMOBJ";
		private const string PerformedActionCodeMeaning = "Performed Action Item 1";
		private const string ProcedureCodeValue = "PC-1";
		private const string ProcedureCodingSchemeDesignator = "DCMOBJ";
		private const string ProcedureCodeMeaning = "Procedure Code 1";
		private const string PerformedProcedureStepStatus = "COMPLETED";


		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
            if (disposing && components != null)
            {
                components.Dispose();
            }
            base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.EnableLog = new CheckBox();
			this.Logger = new TextBox();
			this.CompleteBTN = new Button();
			this.InProgressBTN = new Button();
			this.Label1 = new Label();
			this.SuspendLayout();
			// 
			// EnableLog
			// 
			this.EnableLog.Checked = true;
			this.EnableLog.CheckState = CheckState.Checked;
			this.EnableLog.Location = new System.Drawing.Point(16, 200);
			this.EnableLog.Name = "EnableLog";
			this.EnableLog.Size = new System.Drawing.Size(128, 24);
			this.EnableLog.TabIndex = 9;
			this.EnableLog.Text = "Enable Live Log";
			// 
			// Logger
			// 
			this.Logger.Location = new System.Drawing.Point(176, 64);
			this.Logger.Multiline = true;
			this.Logger.Name = "Logger";
			this.Logger.ScrollBars = ScrollBars.Vertical;
			this.Logger.Size = new System.Drawing.Size(400, 160);
			this.Logger.TabIndex = 8;
			this.Logger.Text = "";
			// 
			// CompleteBTN
			// 
			this.CompleteBTN.Location = new System.Drawing.Point(16, 136);
			this.CompleteBTN.Name = "CompleteBTN";
			this.CompleteBTN.Size = new System.Drawing.Size(128, 64);
			this.CompleteBTN.TabIndex = 7;
			this.CompleteBTN.Text = "Send \"Complete\" Notification";
			this.CompleteBTN.Click += new System.EventHandler(this.CompleteBTN_Click);
			// 
			// InProgressBTN
			// 
			this.InProgressBTN.Location = new System.Drawing.Point(16, 64);
			this.InProgressBTN.Name = "InProgressBTN";
			this.InProgressBTN.Size = new System.Drawing.Size(128, 64);
			this.InProgressBTN.TabIndex = 6;
			this.InProgressBTN.Text = "Send \"In Progress\" Notification";
			this.InProgressBTN.Click += new System.EventHandler(this.InProgressBTN_Click);
			// 
			// Label1
			// 
			this.Label1.Font = new System.Drawing.Font("Microsoft Sans Serif", 10F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.Label1.Location = new System.Drawing.Point(16, 8);
			this.Label1.Name = "Label1";
			this.Label1.Size = new System.Drawing.Size(552, 48);
			this.Label1.TabIndex = 5;
			this.Label1.Text = "Although reasonably generic, this example is designed to work specifically with e" +
				"ither the corresponding DicomObjects MPPS SCP example, or the DVT Dicom Verifica" +
				"tion Tool ";
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(584, 246);
			this.Controls.Add(this.EnableLog);
			this.Controls.Add(this.Logger);
			this.Controls.Add(this.CompleteBTN);
			this.Controls.Add(this.InProgressBTN);
			this.Controls.Add(this.Label1);
			this.Name = "Form1";
			this.Text = "MPPS SCU Sample";
			this.Load += new System.EventHandler(this.Form1_Load);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		delegate void SetTextCallback(TextBox box, string text);

		private void AppendText(TextBox box, string text)
		{
			// InvokeRequired required compares the thread ID of the
			// calling thread to the thread ID of the creating thread.
			// If these threads are different, it returns true.
			if (box.InvokeRequired)
			{
				SetTextCallback d = AppendText;
				Invoke(d, new object[] { box, text });
			}
			else
			{
				box.AppendText(text + "\r\n");
			}
		}

		private void DicomGlobal_LogEvent(LogEventArgs e)
		{
			if(EnableLog.Checked)
				AppendText(Logger, e.Text);
		}

		private void Form1_Load(object sender, EventArgs e)
		{
			//Put the following line back to enable DicomObjects Logging
			//DicomGlobal.LogToFile("c:\\dicom log files", 63);
			DicomGlobal.EventLogLevel = (LogLevel) 0x3F;
			DicomGlobal.LogEvent +=DicomGlobal_LogEvent;                
			UID = DicomGlobal.NewUID();
			StudyUID = DicomGlobal.NewUID();
		}

		private DicomDataSet MakeBaseDataSet()
		{
			DicomDataSet ds = new DicomDataSet();
			emptydss = new DicomDataSetCollection();

			//set up procedure  details
			ds.Name = PatientName; 
			ds.PatientID = PatientId; 
			ds.Sex = Gender; 
			ds.DateOfBirth = Convert.ToDateTime(DateFormat);

			//Patient
			ds.Add(Keyword.ReferencedPatientSequence, emptydss);

			//This has basically the info returend in 0040,0100 from MWL
			DicomDataSetCollection dds = new DicomDataSetCollection();
			DicomDataSet ds1 = new DicomDataSet {StudyUID = StudyUID};
		    ds1.Add(Keyword.ReferencedStudySequence, emptydss);
			ds1.Add(Keyword.AccessionNumber, AccessionNumber);
			ds1.Add(Keyword.RequestedProcedureID, RequestedProcedureID);
			ds1.Add(Keyword.RequestedProcedureDescription, RequestedProcedureDescription);
			ds1.Add(Keyword.ScheduledProcedureStepID, ScheduledProcedureStepId);
			ds1.Add(Keyword.ScheduledProcedureStepDescription, ScheduledProcedureStepDescription);
			ds1.Add(Keyword.ScheduledProtocolCodeSequence, emptydss);

            dds.Add(ds1);
			ds.Add(Keyword.ScheduledStepAttributesSequence, dds);

			ds.Add(Keyword.PerformedStationAETitle, PerformedStationAETitle);
			ds.Add(Keyword.PerformedStationName, PerformedStationName);
			ds.Add(Keyword.PerformedLocation, PerformedLocation);
			ds.Add(Keyword.PerformedProcedureStepStartDate, DateTime.Now);
			ds.Add(Keyword.PerformedProcedureStepStartTime, DateTime.Now);
			ds.Add(Keyword.PerformedProcedureStepID, PerformedProcedureStepID);
			ds.Add(Keyword.PerformedProcedureStepEndDate, "");
			ds.Add(Keyword.PerformedProcedureStepEndTime, "");
			ds.Add(Keyword.PerformedProcedureStepDescription, PerformedProcedureStepDescription);
			ds.Add(Keyword.PerformedProcedureTypeDescription, PerformedProcedureTypeDescription);
			ds.Add(Keyword.Modality, Modality);
			ds.Add(Keyword.StudyID, StudyId);

			return ds;
		}

		private void InProgressBTN_Click(object sender, EventArgs e)
		{
			DicomDataSet  ds;
			DicomAssociation cn= new DicomAssociation();

			ds = MakeBaseDataSet();

			try
			{
				cn.RequestedContexts.Add(SOPClasses.ModalityPerformedProcedureStep);
				cn.Open(Node, Port, CallingAE, CalledAE);

				//following sequences are blank at this stage (filled in when MPPS complete)
				// but they must still be present

				ds.Add(Keyword.PerformedProtocolCodeSequence, emptydss);
				ds.Add(Keyword.ProcedureCodeSequence, emptydss);
				ds.Add(Keyword.PerformedSeriesSequence, emptydss);
				ds.Add(Keyword.PerformedProcedureStepStatus, InProgress);
				cn.NCreate(SOPClasses.ModalityPerformedProcedureStep, UID, ds);

				if(cn.LastStatus == 0)
					MessageBox.Show(SucceededMessage);

				cn.Close();
			}
			catch(Exception ex)
			{
				AppendText(Logger, ex.Message.ToString());
			}
		}

		private void CompleteBTN_Click(object sender, EventArgs e)
		{
			DicomDataSet ds;
			DicomAssociation cn = new DicomAssociation();
			DicomDataSet procedureCode = new DicomDataSet();
			DicomDataSetCollection procedureCodeSQ = new DicomDataSetCollection();
			DicomDataSet protocalCode = new DicomDataSet();
			DicomDataSetCollection  performedProtocalCodeSQ = new DicomDataSetCollection();
			try
			{
				ds = MakeBaseDataSet();
				cn.RequestedContexts.Add(SOPClasses.ModalityPerformedProcedureStep);
				cn.Open(Node, Port, CallingAE, CalledAE);

				// These code values are arbitrary, and would be mapped to local/defined codes for real use
				// There is scope for adding more detail of the examination here if required -
				// - see the DICOM standard for details

				// Performed Action Item Sequence
				protocalCode.Add(Keyword.CodeValue, PerformedActionCodeValue);
				protocalCode.Add(Keyword.CodingSchemeDesignator, PerformedActionCodingSchemeDesignator);
				protocalCode.Add(Keyword.CodeMeaning, PerformedActionCodeMeaning);
				performedProtocalCodeSQ.Add(protocalCode);
				ds.Add(Keyword.PerformedProtocolCodeSequence, performedProtocalCodeSQ);

				// Procedure Code Sequence
				procedureCode.Add(Keyword.CodeValue, ProcedureCodeValue);
				procedureCode.Add(Keyword.CodingSchemeDesignator, ProcedureCodingSchemeDesignator);
				procedureCode.Add(Keyword.CodeMeaning, ProcedureCodeMeaning);
				procedureCodeSQ.Add(procedureCode);
				ds.Add(Keyword.ProcedureCodeSequence, procedureCodeSQ);

				ds.Add(Keyword.PerformedSeriesSequence, emptydss);
				ds.Add(Keyword.PerformedProcedureStepStatus, PerformedProcedureStepStatus);

				cn.NSet(SOPClasses.ModalityPerformedProcedureStep, UID, ds);

				if(cn.LastStatus == 0) 
					MessageBox.Show(SucceededMessage);
				cn.Close();
			}
			catch(Exception ex)
			{
				AppendText(Logger, ex.Message.ToString());
			}
		}

	}
}
